# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b11"
os.chdir("/home/ckoutsch/.sage/sage_notebook/worksheets/admin/24/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
# Computes the b-adic representation of a rational number z, where b must be an integer greater than 1.
# Returns a list [signum, vorkomma, nachkomma, periode] where
#     signum is -1 if z<0 and 1 otherwise
#     vorkomma is a list containing the digits before the decimal point
#     nachkomma is a list containing the digits after the decimal point before the period starts
#     period is a list containing the digits which repeat periodically.
#         In case that the b-adic representation is not periodic, this list is empty.
#
def b_adic_representation(z, b):
    try:
        z = QQ(z)
    except TypeError:
        raise TypeError, "The first input parameter should be a rational number."
    num = z.numerator()
    den = z.denominator()

    # We always want to have that the denominator is greater than 0.
    if den < Integer(0):
        num *= -Integer(1)
        den *= -Integer(1)

    # If z<0 we set the signum, but then continue with -z.
    if num < Integer(0):
        signum = -Integer(1)
        num *= -Integer(1)
    else:
        signum = Integer(1)

    if type(b) != sage.rings.integer.Integer or b < Integer(2):
        raise Exception, "The basis must be an integer greater than 1."

    # Separate the integer part (which gives the digits before the decimal point)
    # and the rational part (which gives the digits after the decimal point).
    # ratPart contains only the numerator of the rational part.
    intPart = num // den
    ratPart = num % den

    # Compute the digits before the decimal point by successive division with remainder.
    vorkomma = []
    if intPart == Integer(0):
        vorkomma = [Integer(0)]
    while intPart != Integer(0):
        vorkomma.append(intPart % b)
        intPart = intPart // b
    vorkomma.reverse()

    # Now compute the digits after the decimal point.
    # In reste we remember all remainders that occur (necessary for detecting the period)
    nachkomma = []
    periode = []
    reste = []
    while ratPart != Integer(0):
        reste.append(ratPart)
        ratPart *= b
        nachkomma.append(ratPart // den)
        ratPart = ratPart % den

        # If we get a remainder that is already in reste, we detected a periodic behaviour.
        # The position of the remainder in reste tells us where the period started.
        # In this case we have to exit the while loop.
        if ratPart in reste:
            periode = nachkomma[reste.index(ratPart):len(reste)]
            nachkomma = nachkomma[Integer(0):reste.index(ratPart)]
            break

    return [signum, vorkomma, nachkomma, periode]

print "e11"
